diff --git a/src/Umbraco.Infrastructure/Runtime/RuntimeModeValidationService.cs b/src/Umbraco.Infrastructure/Runtime/RuntimeModeValidationService.cs
index 85eec91786..c4bbeb6902 100644
--- a/src/Umbraco.Infrastructure/Runtime/RuntimeModeValidationService.cs
+++ b/src/Umbraco.Infrastructure/Runtime/RuntimeModeValidationService.cs
@@ -29,11 +29,18 @@ internal class RuntimeModeValidationService : IRuntimeModeValidationService
         var validationMessages = new List<string>();
 
         // Runtime mode validators are registered transient, but this service is registered as singleton
-        foreach (var runtimeModeValidator in _serviceProvider.GetServices<IRuntimeModeValidator>())
+        using (var scope = _serviceProvider.CreateScope())
         {
-            if (runtimeModeValidator.Validate(runtimeMode, out var validationMessage) == false)
+            var runtimeModeValidators = scope.ServiceProvider.GetService<RuntimeModeValidatorCollection>();
+            if (runtimeModeValidators is not null)
             {
-                validationMessages.Add(validationMessage);
+                foreach (var runtimeModeValidator in runtimeModeValidators)
+                {
+                    if (runtimeModeValidator.Validate(runtimeMode, out var validationMessage) == false)
+                    {
+                        validationMessages.Add(validationMessage);
+                    }
+                }
             }
         }
 
diff --git a/src/Umbraco.Infrastructure/Runtime/RuntimeModeValidatorCollection.cs b/src/Umbraco.Infrastructure/Runtime/RuntimeModeValidatorCollection.cs
new file mode 100644
index 0000000000..97f25f3b8f
--- /dev/null
+++ b/src/Umbraco.Infrastructure/Runtime/RuntimeModeValidatorCollection.cs
@@ -0,0 +1,10 @@
+using Umbraco.Cms.Core.Composing;
+
+namespace Umbraco.Cms.Infrastructure.Runtime;
+
+public class RuntimeModeValidatorCollection : BuilderCollectionBase<IRuntimeModeValidator>
+{
+    public RuntimeModeValidatorCollection(Func<IEnumerable<IRuntimeModeValidator>> items)
+        : base(items)
+    { }
+}
diff --git a/src/Umbraco.Infrastructure/Runtime/RuntimeModeValidatorCollectionBuilder.cs b/src/Umbraco.Infrastructure/Runtime/RuntimeModeValidatorCollectionBuilder.cs
new file mode 100644
index 0000000000..4c755a6040
--- /dev/null
+++ b/src/Umbraco.Infrastructure/Runtime/RuntimeModeValidatorCollectionBuilder.cs
@@ -0,0 +1,11 @@
+using Microsoft.Extensions.DependencyInjection;
+using Umbraco.Cms.Core.Composing;
+
+namespace Umbraco.Cms.Infrastructure.Runtime;
+
+public class RuntimeModeValidatorCollectionBuilder : SetCollectionBuilderBase<RuntimeModeValidatorCollectionBuilder, RuntimeModeValidatorCollection, IRuntimeModeValidator>
+{
+    protected override ServiceLifetime CollectionLifetime => ServiceLifetime.Transient;
+
+    protected override RuntimeModeValidatorCollectionBuilder This => this;
+}
diff --git a/src/Umbraco.Infrastructure/Scoping/IScopeProvider.cs b/src/Umbraco.Infrastructure/Scoping/IScopeProvider.cs
index 19f07c210c..a21abccbf0 100644
--- a/src/Umbraco.Infrastructure/Scoping/IScopeProvider.cs
+++ b/src/Umbraco.Infrastructure/Scoping/IScopeProvider.cs
@@ -11,11 +11,6 @@ namespace Umbraco.Cms.Infrastructure.Scoping;
 /// </summary>
 public interface IScopeProvider : ICoreScopeProvider
 {
-    /// <summary>
-    ///     Gets the scope context.
-    /// </summary>
-    IScopeContext? Context { get; }
-
     /// <inheritdoc />
     ICoreScope ICoreScopeProvider.CreateCoreScope(
         IsolationLevel isolationLevel,
diff --git a/src/Umbraco.Infrastructure/Telemetry/Providers/SystemInformationTelemetryProvider.cs b/src/Umbraco.Infrastructure/Telemetry/Providers/SystemInformationTelemetryProvider.cs
index 84aa2a1bb3..8953b71ce1 100644
--- a/src/Umbraco.Infrastructure/Telemetry/Providers/SystemInformationTelemetryProvider.cs
+++ b/src/Umbraco.Infrastructure/Telemetry/Providers/SystemInformationTelemetryProvider.cs
@@ -1,4 +1,4 @@
-using System.Diagnostics;
+﻿using System.Diagnostics;
 using System.Runtime.InteropServices;
 using Microsoft.Extensions.Hosting;
 using Microsoft.Extensions.Options;
@@ -7,6 +7,7 @@ using Umbraco.Cms.Core.Configuration;
 using Umbraco.Cms.Core.Configuration.Models;
 using Umbraco.Cms.Core.Models;
 using Umbraco.Cms.Core.Services;
+using Umbraco.Cms.Core.Sync;
 using Umbraco.Cms.Infrastructure.Persistence;
 using Umbraco.Cms.Infrastructure.Telemetry.Interfaces;
 using Umbraco.Extensions;
@@ -22,6 +23,8 @@ internal class SystemInformationTelemetryProvider : IDetailedTelemetryProvider,
     private readonly ModelsBuilderSettings _modelsBuilderSettings;
     private readonly IUmbracoDatabaseFactory _umbracoDatabaseFactory;
     private readonly IUmbracoVersion _version;
+    private readonly IServerRoleAccessor _serverRoleAccessor;
+
 
     public SystemInformationTelemetryProvider(
         IUmbracoVersion version,
@@ -30,12 +33,14 @@ internal class SystemInformationTelemetryProvider : IDetailedTelemetryProvider,
         IOptionsMonitor<HostingSettings> hostingSettings,
         IOptionsMonitor<GlobalSettings> globalSettings,
         IHostEnvironment hostEnvironment,
-        IUmbracoDatabaseFactory umbracoDatabaseFactory)
+        IUmbracoDatabaseFactory umbracoDatabaseFactory,
+        IServerRoleAccessor serverRoleAccessor)
     {
         _version = version;
         _localizationService = localizationService;
         _hostEnvironment = hostEnvironment;
         _umbracoDatabaseFactory = umbracoDatabaseFactory;
+        _serverRoleAccessor = serverRoleAccessor;
 
         _globalSettings = globalSettings.CurrentValue;
         _hostingSettings = hostingSettings.CurrentValue;
@@ -60,6 +65,8 @@ internal class SystemInformationTelemetryProvider : IDetailedTelemetryProvider,
 
     private string DatabaseProvider => _umbracoDatabaseFactory.CreateDatabase().DatabaseType.GetProviderName();
 
+    private string CurrentServerRole => _serverRoleAccessor.CurrentServerRole.ToString();
+
     public IEnumerable<UsageInformation> GetInformation() =>
         new UsageInformation[]
         {
@@ -70,6 +77,7 @@ internal class SystemInformationTelemetryProvider : IDetailedTelemetryProvider,
             new(Constants.Telemetry.CustomUmbracoPath, UmbracoPathCustomized),
             new(Constants.Telemetry.AspEnvironment, AspEnvironment), new(Constants.Telemetry.IsDebug, IsDebug),
             new(Constants.Telemetry.DatabaseProvider, DatabaseProvider),
+            new(Constants.Telemetry.CurrentServerRole, CurrentServerRole),
         };
 
     public IEnumerable<UserData> GetUserData() =>
@@ -82,6 +90,7 @@ internal class SystemInformationTelemetryProvider : IDetailedTelemetryProvider,
             new("Current UI Culture", Thread.CurrentThread.CurrentUICulture.ToString()),
             new("Current Webserver", CurrentWebServer), new("Models Builder Mode", ModelsBuilderMode),
             new("Debug Mode", IsDebug.ToString()), new("Database Provider", DatabaseProvider),
+            new("Current Server Role", CurrentServerRole),
         };
 
     private bool IsRunningInProcessIIS()
diff --git a/src/Umbraco.Infrastructure/Umbraco.Infrastructure.csproj b/src/Umbraco.Infrastructure/Umbraco.Infrastructure.csproj
index fc41bec6c5..7d48468a96 100644
--- a/src/Umbraco.Infrastructure/Umbraco.Infrastructure.csproj
+++ b/src/Umbraco.Infrastructure/Umbraco.Infrastructure.csproj
@@ -48,7 +48,7 @@
       <PackageReference Include="Serilog.Sinks.Async" Version="1.5.0" />
       <PackageReference Include="Serilog.Sinks.File" Version="5.0.0" />
       <PackageReference Include="Serilog.Sinks.Map" Version="1.0.2" />
-      <PackageReference Include="SixLabors.ImageSharp" Version="2.1.2" />
+      <PackageReference Include="SixLabors.ImageSharp" Version="2.1.3" />
       <PackageReference Include="System.IO.FileSystem.AccessControl" Version="5.0.0" />
       <PackageReference Include="System.Security.Cryptography.Pkcs" Version="6.0.1" />
       <PackageReference Include="System.Text.Encodings.Web" Version="6.0.0" /> <!-- Explicit updated this nested dependency due to this https://github.com/dotnet/announcements/issues/178-->
diff --git a/src/Umbraco.Web.BackOffice/Controllers/BackOfficeServerVariables.cs b/src/Umbraco.Web.BackOffice/Controllers/BackOfficeServerVariables.cs
index e44219b681..898efe1938 100644
--- a/src/Umbraco.Web.BackOffice/Controllers/BackOfficeServerVariables.cs
+++ b/src/Umbraco.Web.BackOffice/Controllers/BackOfficeServerVariables.cs
@@ -598,7 +598,7 @@ namespace Umbraco.Cms.Web.BackOffice.Controllers
                 { "assemblyVersion", _umbracoVersion.AssemblyVersion?.ToString() }
             };
 
-
+            app.Add("runtimeMode", _runtimeSettings.Mode.ToString());
 
             //the value is the hash of the version, cdf version and the configured state
             app.Add("cacheBuster", $"{version}.{_runtimeState.Level}.{_runtimeMinifier.CacheBuster}".GenerateHash());
diff --git a/src/Umbraco.Web.BackOffice/Controllers/ContentController.cs b/src/Umbraco.Web.BackOffice/Controllers/ContentController.cs
index bb8d6335d6..7481b4e1ff 100644
--- a/src/Umbraco.Web.BackOffice/Controllers/ContentController.cs
+++ b/src/Umbraco.Web.BackOffice/Controllers/ContentController.cs
@@ -528,6 +528,8 @@ public class ContentController : ContentControllerBase
         {
             display.DocumentType.Name =
                 _localizedTextService.UmbracoDictionaryTranslate(CultureDictionary, display.DocumentType.Name);
+            display.DocumentType.Description =
+                _localizedTextService.UmbracoDictionaryTranslate(CultureDictionary, display.DocumentType.Description);
         }
 
         //remove the listview app if it exists
@@ -1860,6 +1862,11 @@ public class ContentController : ContentControllerBase
 
     private IEnumerable<string> GetPublishedCulturesFromAncestors(IContent? content)
     {
+        if (content?.ParentId is not -1 && content?.HasIdentity is false)
+        {
+            content = _contentService.GetById(content.ParentId);
+        }
+
         if (content?.ParentId == -1)
         {
             return content.PublishedCultures;
diff --git a/src/Umbraco.Web.BackOffice/Controllers/DictionaryController.cs b/src/Umbraco.Web.BackOffice/Controllers/DictionaryController.cs
index ad55272587..b9508a501b 100644
--- a/src/Umbraco.Web.BackOffice/Controllers/DictionaryController.cs
+++ b/src/Umbraco.Web.BackOffice/Controllers/DictionaryController.cs
@@ -1,3 +1,4 @@
+using System.Xml;
 using System.Globalization;
 using System.Net.Mime;
 using System.Text;
@@ -10,11 +11,17 @@ using Umbraco.Cms.Core.Configuration.Models;
 using Umbraco.Cms.Core.Mapping;
 using Umbraco.Cms.Core.Models;
 using Umbraco.Cms.Core.Models.ContentEditing;
+using Umbraco.Cms.Core.Hosting;
 using Umbraco.Cms.Core.Security;
 using Umbraco.Cms.Core.Services;
 using Umbraco.Cms.Web.Common.Attributes;
 using Umbraco.Cms.Web.Common.Authorization;
 using Umbraco.Extensions;
+using Umbraco.Cms.Infrastructure.Packaging;
+using System.Xml.Linq;
+using Microsoft.AspNetCore.Http;
+using Microsoft.Extensions.DependencyInjection;
+using Umbraco.Cms.Web.Common.DependencyInjection;
 
 namespace Umbraco.Cms.Web.BackOffice.Controllers;
 
@@ -38,7 +45,34 @@ public class DictionaryController : BackOfficeNotificationsController
     private readonly ILocalizedTextService _localizedTextService;
     private readonly ILogger<DictionaryController> _logger;
     private readonly IUmbracoMapper _umbracoMapper;
+    private readonly IEntityXmlSerializer _serializer;
+    private readonly IHostingEnvironment _hostingEnvironment;
+    private readonly PackageDataInstallation _packageDataInstallation;
 
+    [ActivatorUtilitiesConstructor]
+    public DictionaryController(
+        ILogger<DictionaryController> logger,
+        ILocalizationService localizationService,
+        IBackOfficeSecurityAccessor backofficeSecurityAccessor,
+        IOptionsSnapshot<GlobalSettings> globalSettings,
+        ILocalizedTextService localizedTextService,
+        IUmbracoMapper umbracoMapper,
+        IEntityXmlSerializer serializer,
+        IHostingEnvironment hostingEnvironment,
+        PackageDataInstallation packageDataInstallation)
+    {
+        _logger = logger ?? throw new ArgumentNullException(nameof(logger));
+        _localizationService = localizationService ?? throw new ArgumentNullException(nameof(localizationService));
+        _backofficeSecurityAccessor = backofficeSecurityAccessor ?? throw new ArgumentNullException(nameof(backofficeSecurityAccessor));
+        _globalSettings = globalSettings.Value ?? throw new ArgumentNullException(nameof(globalSettings));
+        _localizedTextService = localizedTextService ?? throw new ArgumentNullException(nameof(localizedTextService));
+        _umbracoMapper = umbracoMapper ?? throw new ArgumentNullException(nameof(umbracoMapper));
+        _serializer = serializer ?? throw new ArgumentNullException(nameof(serializer));
+        _hostingEnvironment = hostingEnvironment ?? throw new ArgumentNullException(nameof(hostingEnvironment));
+        _packageDataInstallation = packageDataInstallation ?? throw new ArgumentNullException(nameof(packageDataInstallation));
+    }
+
+    [Obsolete("Please use ctor that also takes an IEntityXmlSerializer, IHostingEnvironment & PackageDataInstallation instead, scheduled for removal in v12")]
     public DictionaryController(
         ILogger<DictionaryController> logger,
         ILocalizationService localizationService,
@@ -46,14 +80,17 @@ public class DictionaryController : BackOfficeNotificationsController
         IOptionsSnapshot<GlobalSettings> globalSettings,
         ILocalizedTextService localizedTextService,
         IUmbracoMapper umbracoMapper)
+    : this(
+        logger,
+        localizationService,
+        backofficeSecurityAccessor,
+        globalSettings,
+        localizedTextService,
+        umbracoMapper,
+        StaticServiceProvider.Instance.GetRequiredService<IEntityXmlSerializer>(),
+        StaticServiceProvider.Instance.GetRequiredService<IHostingEnvironment>(),
+        StaticServiceProvider.Instance.GetRequiredService<PackageDataInstallation>())
     {
-        _logger = logger ?? throw new ArgumentNullException(nameof(logger));
-        _localizationService = localizationService ?? throw new ArgumentNullException(nameof(localizationService));
-        _backofficeSecurityAccessor = backofficeSecurityAccessor ??
-                                      throw new ArgumentNullException(nameof(backofficeSecurityAccessor));
-        _globalSettings = globalSettings.Value ?? throw new ArgumentNullException(nameof(globalSettings));
-        _localizedTextService = localizedTextService ?? throw new ArgumentNullException(nameof(localizedTextService));
-        _umbracoMapper = umbracoMapper ?? throw new ArgumentNullException(nameof(umbracoMapper));
     }
 
     /// <summary>
@@ -389,5 +426,134 @@ public class DictionaryController : BackOfficeNotificationsController
         }
     }
 
+    public IActionResult ExportDictionary(int id, bool includeChildren = false)
+    {
+        IDictionaryItem? dictionaryItem = _localizationService.GetDictionaryItemById(id);
+        if (dictionaryItem == null)
+        {
+            throw new NullReferenceException("No dictionary item found with id " + id);
+        }
+
+        XElement xml = _serializer.Serialize(dictionaryItem, includeChildren);
+
+        var fileName = $"{dictionaryItem.ItemKey}.udt";
+        // Set custom header so umbRequestHelper.downloadFile can save the correct filename
+        HttpContext.Response.Headers.Add("x-filename", fileName);
+
+        return File(Encoding.UTF8.GetBytes(xml.ToDataString()), MediaTypeNames.Application.Octet, fileName);
+    }
+
+    public IActionResult ImportDictionary(string file, int parentId)
+    {
+        if (string.IsNullOrWhiteSpace(file))
+        {
+            return NotFound();
+        }
+
+        var filePath = Path.Combine(_hostingEnvironment.MapPathContentRoot(Constants.SystemDirectories.Data), file);
+        if (!System.IO.File.Exists(filePath))
+        {
+            return NotFound();
+        }
+
+        var xd = new XmlDocument { XmlResolver = null };
+        xd.Load(filePath);
+
+        var userId = _backofficeSecurityAccessor.BackOfficeSecurity?.GetUserId().Result ?? 0;
+        var element = XElement.Parse(xd.InnerXml);
+
+        IDictionaryItem? parentDictionaryItem = _localizationService.GetDictionaryItemById(parentId);
+        IEnumerable<IDictionaryItem> dictionaryItems = _packageDataInstallation
+            .ImportDictionaryItem(element, userId, parentDictionaryItem?.Key);
+
+        // Try to clean up the temporary file.
+        try
+        {
+            System.IO.File.Delete(filePath);
+        }
+        catch (Exception ex)
+        {
+            _logger.LogError(ex, "Error cleaning up temporary udt file in {File}", filePath);
+        }
+
+        var model = _umbracoMapper.Map<IDictionaryItem, DictionaryDisplay>(dictionaryItems.FirstOrDefault());
+        return Content(model!.Path, MediaTypeNames.Text.Plain, Encoding.UTF8);
+    }
+
+    public ActionResult<DictionaryImportModel> Upload(IFormFile file)
+    {
+        if (file == null)
+        {
+            return ValidationProblem(
+                _localizedTextService.Localize("media", "failedFileUpload"),
+                _localizedTextService.Localize("speechBubbles", "fileErrorNotFound"));
+        }
+
+        var fileName = file.FileName.Trim(Constants.CharArrays.DoubleQuote);
+        var ext = fileName.Substring(fileName.LastIndexOf('.') + 1).ToLower();
+        var root = _hostingEnvironment.MapPathContentRoot(Constants.SystemDirectories.TempFileUploads);
+        var tempPath = Path.Combine(root, fileName);
+
+        if (!Path.GetFullPath(tempPath).StartsWith(Path.GetFullPath(root)))
+        {
+            return ValidationProblem(
+                _localizedTextService.Localize("media", "failedFileUpload"),
+                _localizedTextService.Localize("media", "invalidFileName"));
+        }
+
+        if (!ext.InvariantEquals("udt"))
+        {
+            return ValidationProblem(
+                _localizedTextService.Localize("media", "failedFileUpload"),
+                _localizedTextService.Localize("media", "disallowedFileType"));
+        }
+
+        using (FileStream stream = System.IO.File.Create(tempPath))
+        {
+            file.CopyToAsync(stream).GetAwaiter().GetResult();
+        }
+
+        var xd = new XmlDocument { XmlResolver = null };
+        xd.Load(tempPath);
+
+        if (xd.DocumentElement == null)
+        {
+            return ValidationProblem(
+                _localizedTextService.Localize("media", "failedFileUpload"),
+                _localizedTextService.Localize("speechBubbles", "fileErrorNotFound"));
+        }
+
+        var model = new DictionaryImportModel()
+        {
+            TempFileName = tempPath,
+            DictionaryItems = new List<DictionaryPreviewImportModel>(),
+        };
+
+        var level = 1;
+        var currentParent = string.Empty;
+        foreach (XmlNode dictionaryItem in xd.GetElementsByTagName("DictionaryItem"))
+        {
+            var name = dictionaryItem.Attributes?.GetNamedItem("Name")?.Value ?? string.Empty;
+            var parentKey = dictionaryItem?.ParentNode?.Attributes?.GetNamedItem("Key")?.Value ?? string.Empty;
+
+            if (parentKey != currentParent || level == 1)
+            {
+                level += 1;
+                currentParent = parentKey;
+            }
+
+            model.DictionaryItems.Add(new DictionaryPreviewImportModel() { Level = level, Name = name });
+        }
+
+        if (!model.DictionaryItems.Any())
+        {
+            return ValidationProblem(
+                _localizedTextService.Localize("media", "failedFileUpload"),
+                _localizedTextService.Localize("dictionary", "noItemsInFile"));
+        }
+
+        return model;
+    }
+
     private static Func<IDictionaryItem, string> ItemSort() => item => item.ItemKey;
 }
diff --git a/src/Umbraco.Web.BackOffice/Controllers/EntityController.cs b/src/Umbraco.Web.BackOffice/Controllers/EntityController.cs
index 3f51e909b9..c8bb55c44c 100644
--- a/src/Umbraco.Web.BackOffice/Controllers/EntityController.cs
+++ b/src/Umbraco.Web.BackOffice/Controllers/EntityController.cs
@@ -199,6 +199,7 @@ public class EntityController : UmbracoAuthorizedJsonController
             return result;
         }
 
+        var culture = ClientCulture();
         var allowedSections = _backofficeSecurityAccessor.BackOfficeSecurity?.CurrentUser?.AllowedSections.ToArray();
 
         var searchTasks = new List<Task>();
@@ -216,7 +217,7 @@ public class EntityController : UmbracoAuthorizedJsonController
                 var rootNodeDisplayName = Tree.GetRootNodeDisplayName(tree, _localizedTextService);
                 if (rootNodeDisplayName is not null)
                 {
-                    searchTasks.Add(ExecuteSearchAsync(query, searchableTree, rootNodeDisplayName, result));
+                    searchTasks.Add(ExecuteSearchAsync(query, culture, searchableTree, rootNodeDisplayName, result));
                 }
             }
         }
@@ -227,13 +228,22 @@ public class EntityController : UmbracoAuthorizedJsonController
 
     private static async Task ExecuteSearchAsync(
         string query,
+        string? culture,
         KeyValuePair<string, SearchableApplicationTree> searchableTree,
         string rootNodeDisplayName,
         ConcurrentDictionary<string, TreeSearchResult> result)
     {
+        ISearchableTree searcher = searchableTree.Value.SearchableTree;
+        const int pageSize = 200;
+        IEnumerable<SearchResultEntity> results = (
+            searcher is ISearchableTreeWithCulture searcherWithCulture
+                ? await searcherWithCulture.SearchAsync(query, pageSize, 0, culture: culture)
+                : await searcher.SearchAsync(query, pageSize, 0))
+        .WhereNotNull();
+
         var searchResult = new TreeSearchResult
         {
-            Results = (await searchableTree.Value.SearchableTree.SearchAsync(query, 200, 0)).WhereNotNull(),
+            Results = results,
             TreeAlias = searchableTree.Key,
             AppAlias = searchableTree.Value.AppAlias,
             JsFormatterService = searchableTree.Value.FormatterService,
diff --git a/src/Umbraco.Web.BackOffice/Controllers/UsersController.cs b/src/Umbraco.Web.BackOffice/Controllers/UsersController.cs
index 24e5a77a23..f734d8626b 100644
--- a/src/Umbraco.Web.BackOffice/Controllers/UsersController.cs
+++ b/src/Umbraco.Web.BackOffice/Controllers/UsersController.cs
@@ -179,8 +179,9 @@ public class UsersController : BackOfficeNotificationsController
         var fileName = file.FileName.Trim(new[] { '\"' }).TrimEnd();
         var safeFileName = fileName.ToSafeFileName(shortStringHelper);
         var ext = safeFileName.Substring(safeFileName.LastIndexOf('.') + 1).ToLower();
+        const string allowedAvatarFileTypes = "jpeg,jpg,gif,bmp,png,tiff,tif,webp";
 
-        if (contentSettings.DisallowedUploadFiles.Contains(ext) == false)
+        if (allowedAvatarFileTypes.Contains(ext) == true && contentSettings.DisallowedUploadFiles.Contains(ext) == false)
         {
             //generate a path of known data, we don't want this path to be guessable
             user.Avatar = "UserAvatars/" + (user.Id + safeFileName).GenerateHash<SHA1>() + "." + ext;
diff --git a/src/Umbraco.Web.BackOffice/Trees/ContentBlueprintTreeController.cs b/src/Umbraco.Web.BackOffice/Trees/ContentBlueprintTreeController.cs
index db07717b40..d876fdc23e 100644
--- a/src/Umbraco.Web.BackOffice/Trees/ContentBlueprintTreeController.cs
+++ b/src/Umbraco.Web.BackOffice/Trees/ContentBlueprintTreeController.cs
@@ -143,7 +143,7 @@ public class ContentBlueprintTreeController : TreeController
         if (id == Constants.System.RootString)
         {
             // root actions
-            menu.Items.Add<ActionNew>(LocalizedTextService, opensDialog: true);
+            menu.Items.Add<ActionNew>(LocalizedTextService, opensDialog: true, useLegacyIcon: false);
             menu.Items.Add(new RefreshNode(LocalizedTextService, true));
             return menu;
         }
@@ -155,7 +155,7 @@ public class ContentBlueprintTreeController : TreeController
         {
             IContentType? ct = _contentTypeService.Get(cte.Id);
             MenuItem? createItem =
-                menu.Items.Add<ActionCreateBlueprintFromContent>(LocalizedTextService, opensDialog: true);
+                menu.Items.Add<ActionCreateBlueprintFromContent>(LocalizedTextService, opensDialog: true, useLegacyIcon: false);
             createItem?.NavigateToRoute("/settings/contentBlueprints/edit/-1?create=true&doctype=" + ct?.Alias);
 
             menu.Items.Add(new RefreshNode(LocalizedTextService, true));
@@ -163,7 +163,7 @@ public class ContentBlueprintTreeController : TreeController
             return menu;
         }
 
-        menu.Items.Add<ActionDelete>(LocalizedTextService, opensDialog: true);
+        menu.Items.Add<ActionDelete>(LocalizedTextService, opensDialog: true, useLegacyIcon: false);
 
         return menu;
     }
diff --git a/src/Umbraco.Web.BackOffice/Trees/ContentTreeController.cs b/src/Umbraco.Web.BackOffice/Trees/ContentTreeController.cs
index ee1fde64f4..4728ebbca8 100644
--- a/src/Umbraco.Web.BackOffice/Trees/ContentTreeController.cs
+++ b/src/Umbraco.Web.BackOffice/Trees/ContentTreeController.cs
@@ -28,7 +28,7 @@ namespace Umbraco.Cms.Web.BackOffice.Trees;
 [PluginController(Constants.Web.Mvc.BackOfficeTreeArea)]
 [CoreTree]
 [SearchableTree("searchResultFormatter", "configureContentResult", 10)]
-public class ContentTreeController : ContentTreeControllerBase, ISearchableTree
+public class ContentTreeController : ContentTreeControllerBase, ISearchableTreeWithCulture
 {
     private readonly ActionCollection _actions;
     private readonly AppCaches _appCaches;
@@ -104,7 +104,6 @@ public class ContentTreeController : ContentTreeControllerBase, ISearchableTree
         return new EntitySearchResults(results, totalFound);
     }
 
-
     /// <inheritdoc />
     protected override TreeNode? GetSingleTreeNode(IEntitySlim entity, string parentId, FormCollection? queryStrings)
     {
@@ -196,8 +195,8 @@ public class ContentTreeController : ContentTreeControllerBase, ISearchableTree
                 .Select(x => new MenuItem(x));
 
             //these two are the standard items
-            menu.Items.Add<ActionNew>(LocalizedTextService, opensDialog: true);
-            menu.Items.Add<ActionSort>(LocalizedTextService, true, true);
+            menu.Items.Add<ActionNew>(LocalizedTextService, opensDialog: true, useLegacyIcon: false);
+            menu.Items.Add<ActionSort>(LocalizedTextService, hasSeparator: true, opensDialog: true, useLegacyIcon: false);
 
             //filter the standard items
             FilterUserAllowedMenuItems(menu, nodeActions);
@@ -301,23 +300,24 @@ public class ContentTreeController : ContentTreeControllerBase, ISearchableTree
     protected MenuItemCollection GetAllNodeMenuItems(IUmbracoEntity item)
     {
         MenuItemCollection menu = _menuItemCollectionFactory.Create();
-        AddActionNode<ActionNew>(item, menu, opensDialog: true);
-        AddActionNode<ActionDelete>(item, menu, opensDialog: true);
-        AddActionNode<ActionCreateBlueprintFromContent>(item, menu, opensDialog: true);
-        AddActionNode<ActionMove>(item, menu, true, true);
-        AddActionNode<ActionCopy>(item, menu, opensDialog: true);
-        AddActionNode<ActionSort>(item, menu, true, true);
-        AddActionNode<ActionAssignDomain>(item, menu, opensDialog: true);
-        AddActionNode<ActionRights>(item, menu, opensDialog: true);
-        AddActionNode<ActionProtect>(item, menu, true, true);
+        AddActionNode<ActionNew>(item, menu, opensDialog: true, useLegacyIcon: false);
+        AddActionNode<ActionDelete>(item, menu, opensDialog: true, useLegacyIcon: false);
+        AddActionNode<ActionCreateBlueprintFromContent>(item, menu, opensDialog: true, useLegacyIcon: false);
+        AddActionNode<ActionMove>(item, menu, hasSeparator: true, opensDialog: true, useLegacyIcon: false);
+        AddActionNode<ActionCopy>(item, menu, opensDialog: true, useLegacyIcon: false);
+        AddActionNode<ActionSort>(item, menu, hasSeparator: true, opensDialog: true, useLegacyIcon: false);
+        AddActionNode<ActionAssignDomain>(item, menu, opensDialog: true, useLegacyIcon: false);
+        AddActionNode<ActionRights>(item, menu, opensDialog: true, useLegacyIcon: false);
+        AddActionNode<ActionProtect>(item, menu, hasSeparator: true, opensDialog: true, useLegacyIcon: false);
 
         if (_emailSender.CanSendRequiredEmail())
         {
             menu.Items.Add(new MenuItem("notify", LocalizedTextService)
             {
-                Icon = "megaphone",
+                Icon = "icon-megaphone",
                 SeparatorBefore = true,
-                OpensDialog = true
+                OpensDialog = true,
+                UseLegacyIcon = false
             });
         }
 
@@ -337,9 +337,9 @@ public class ContentTreeController : ContentTreeControllerBase, ISearchableTree
     protected MenuItemCollection GetNodeMenuItemsForDeletedContent(IUmbracoEntity item)
     {
         MenuItemCollection menu = _menuItemCollectionFactory.Create();
-        menu.Items.Add<ActionRestore>(LocalizedTextService, opensDialog: true);
-        menu.Items.Add<ActionMove>(LocalizedTextService, opensDialog: true);
-        menu.Items.Add<ActionDelete>(LocalizedTextService, opensDialog: true);
+        menu.Items.Add<ActionRestore>(LocalizedTextService, opensDialog: true, useLegacyIcon: false);
+        menu.Items.Add<ActionMove>(LocalizedTextService, opensDialog: true, useLegacyIcon: false);
+        menu.Items.Add<ActionDelete>(LocalizedTextService, opensDialog: true, useLegacyIcon: false);
 
         menu.Items.Add(new RefreshNode(LocalizedTextService, true));
 
@@ -392,9 +392,15 @@ public class ContentTreeController : ContentTreeControllerBase, ISearchableTree
         }
     }
 
-    private void AddActionNode<TAction>(IUmbracoEntity item, MenuItemCollection menu, bool hasSeparator = false, bool opensDialog = false)
+    private void AddActionNode<TAction>(IUmbracoEntity item, MenuItemCollection menu, bool hasSeparator = false, bool opensDialog = false, bool useLegacyIcon = true)
         where TAction : IAction
     {
-        MenuItem? menuItem = menu.Items.Add<TAction>(LocalizedTextService, hasSeparator, opensDialog);
+        MenuItem? menuItem = menu.Items.Add<TAction>(LocalizedTextService, hasSeparator, opensDialog, useLegacyIcon);
+    }
+
+    public async Task<EntitySearchResults> SearchAsync(string query, int pageSize, long pageIndex, string? searchFrom = null, string? culture = null)
+    {
+        var results = _treeSearcher.ExamineSearch(query, UmbracoEntityTypes.Document, pageSize, pageIndex, out long totalFound, culture: culture, searchFrom: searchFrom);
+        return new EntitySearchResults(results, totalFound);
     }
 }
